//
// Resource Editor 0.01q for Linux    Qt Widgetekkel
//

// ******* Headerfileok ***********

#include <stdlib.h>
#include <fcntl.h>
#include <math.h>
#include <unistd.h>

#include <qpushbt.h>
#include <qpopmenu.h>
#include <qdialog.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qscrbar.h>
#include <qmsgbox.h>
#include <qfiledlg.h>
#include <qapp.h>
#include <qevent.h>
#include <qframe.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qlistbox.h>
#include <qlined.h>
#include <qpixmap.h>
#include <qfile.h>
#include <qbitmap.h>

#include "toolbar/bmphandler.h"
#include "toolbar/toolbar.h"
#include "movements.res"

//***** Bitmap Resources **************

#include "toolbar/rock50.h"

//***** Constant definitions **********

#define WinX 380
#define WinY 300

#define round(a) (int)floor(a+0.5)

#define rr2(a) (a       & 0x0000ff)
#define gg2(a) (a >> 8  & 0x0000ff)
#define bb2(a) (a >> 16 & 0x0000ff)

char bmempty[]=
"{
0x42,0x4d,0x78,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x78,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x01,0x00,0x04,0x00,0x00,0x00,
0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x80,
0x00,0x00,0x00,0x80,0x80,0x00,0x80,0x00,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x80,
0x00,0x00,0x80,0x80,0x80,0x00,0xc0,0xc0,0xc0,0x00,0x00,0x00,0xff,0x00,0x00,0xff,
0x00,0x00,0x00,0xff,0xff,0x00,0xff,0x00,0x00,0x00,0xff,0x00,0xff,0x00,0xff,0xff,
0x00,0x00,0xff,0xff,0xff,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
};
";

char crempty1[]=
"   0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
";

char crempty2[]=
"   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
";

//******* Globlis Tpusdeklarcik ********************

typedef struct TPoint
{
  int  x;
  int  y;
} TPoint;  

//****** Pascal szer String opertorok ********
//****** meg ami mg hinyzott a Pascalbl *****

int chpos(char a, char *s)
{
  int i;
  i=0;
  while( (s[i] != a) && (s[i] != '\0') ) { i++; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int nopos(char a, char *s)
{
  int i;
  i=0;
  while( (s[i] == a) && (s[i] != '\0') ) { i++; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int rchpos(char a, char *s)
{
  int i;
  i=strlen(s);
  while( (s[i] != a) && (i>=0) ) { i--; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int toInt(char *s)
{
  long i;
  unsigned short w;
  w = (sscanf(s, "%ld", &i) == 0);
  return(i);
}

int hxToDec(char *s)
{
  char Hx[17] = "0123456789abcdef";
  int i;
  i  = chpos(tolower(s[0]), Hx) * 16;
  i += chpos(tolower(s[1]), Hx);
  return i;
}

/* int hxToDec(char *s)
{
  int i;
  sscanf(s,"%x",&i);
  return i;
}*/

char *strsub(char *R, char *s, int f, int l)
{
  char T[256];
  int  i;
  for (i = 0; i < l; i++)
    T[i] = s[i + f];
  T[i] = '\0';
  return strcpy(R,T);
}

char *readln(FILE *f,char *R)
{
  char T[256];
  char *t;
  t=fgets(T, 256, f);
  if(strlen(t)!=0)
    {
      t = strchr(T, '\n');
        if (t != NULL)
          *t = 0;
    }   
  else
    strcpy(T,"");  
  return strcpy(R,T);
}

char *nevtoext(char *R, char *s, char *x)
{
  char T[256];
  int  i;
  strcpy(T,s);
  i=rchpos('.',s);
  if(i==0)
    {
      strcat(T,".");
      strcat(T,x);
    }  
  return strcpy(R,T);
}

char *path2fname(char *A)
{
  char T[256],t[256];
  int  i;
  i=rchpos('/',A);
  if(i!=0)
    strsub(T,A,i+1,strlen(A)-i-1);
  else
    strcpy(T,A);  
  return strcpy(t,T);
}

int rnd( int max )
{
  return( int( drand48()*max));
}

//******* Objektumdefincik *******************

class NFile : public QFile
{
public:
    NFile(const char* name);
    Write(char *ln);
    WriteLn(char *ln);
};

#ifndef __INPUTBOX_H__
#define __INPUTBOX_H__
class InputBox : public QDialog
{
    Q_OBJECT;
public:
    QLineEdit* aLine;
    InputBox(QWidget* parent = NULL, const char* name = NULL);
};
#endif

#ifndef __XYINPUT_H__
#define __XYINPUT_H__
class XYInput : public QDialog
{
    Q_OBJECT;
public:
    QLineEdit* xLine;
    QLineEdit* yLine;
    XYInput(QWidget* parent = NULL, const char* name = NULL);
};
#endif

//********* Ablak Alapobjektum ***************

#ifndef __RESEDALAP_H__
#define __RESEDALAP_H__
class ResEdMain : public NWidget
{
    Q_OBJECT
public:

    int        isPreload = FALSE;
    int        numItem;
    int        ixItem;
    
    char       fname[256],fnameB[256];

    ResEdMain( QWidget *parent=0, const char *name=0 );
    
    void        resValogat(char *form, char *path, char *rn, char *ext);

    void	q_usefile(char *rname);

public slots:
    void	q_new();
    void	q_use();
    void	q_reopen();
    
    void	q_flush();
    
    void	q_about();
    
    void        q_insbmp();
    void        q_inscrs();
    void        q_cpynew();
    void	q_delete();
    
    void        q_moveAB();
    void        q_moveBA();
    
    void        q_newB();
    void        q_useB();
    void        q_flushB();
    void        q_deleteB();

    void	q_reopenB();

    void        ItemHighlighted(int ix);
    void        ItemSelected(int ix);
    
protected:
    void	resizeEvent( QResizeEvent * );
    
private:
    QToolButton  *ABbutt,*BAbutt;

    QLabel      *Abox,*Bbox;
    QListBox    *lb,*Alb,*Blb;

    QMenuBar	*menu;
};
#endif // __ALAP_H__

//**** Objektumok ************************************

NFile::NFile(const char* name)
      :QFile(name)
{
}      

NFile::Write(char *ln)
{
   writeBlock(ln,strlen(ln));
}

NFile::WriteLn(char *ln)
{
   char sor[512];
   sprintf(sor,"%s\n",ln);
   writeBlock(sor,strlen(sor));
}

//**** InputBox   ************************************

InputBox::InputBox(QWidget* parent, const char* name)
         :QDialog( parent, name, TRUE )
{
	aLine = new QLineEdit( this );
	aLine->setGeometry( 10, 10, 165, 25 );
	aLine->setText( "" );
        connect( aLine, SIGNAL(returnPressed()), SLOT(accept()) );

	QPushButton *OkButton,*CancButton;
	OkButton = new QPushButton( this );
	OkButton->setGeometry( 10, 40, 70, 25 );
	OkButton->setText( "O&k" );
        connect( OkButton, SIGNAL(clicked()), SLOT(accept()) );

	CancButton = new QPushButton( this );
	CancButton->setGeometry( 85, 40, 90, 25 );
	CancButton->setText( "&Cancel" );
        connect( CancButton, SIGNAL(clicked()), SLOT(reject()) );

	parent->resize( 185, 75 );
        aLine->setFocus();
}

//**** XYInput Box ************************************

XYInput::XYInput(QWidget* parent = NULL, const char* name = NULL)
        :QDialog( parent, name, TRUE )
{
	QLabel* tmpQLabel;
	tmpQLabel = new QLabel( this, "Label_1" );
	tmpQLabel->setGeometry( 10, 15, 25, 25 );
	tmpQLabel->setText( "X:" );
	tmpQLabel = new QLabel( this, "Label_2" );
	tmpQLabel->setGeometry( 10, 50, 25, 25 );
	tmpQLabel->setText( "Y:" );

	xLine = new QLineEdit( this, "XLine" );
	xLine->setGeometry( 40, 15, 125, 25 );
	xLine->setText( "" );
        connect( xLine, SIGNAL(returnPressed()), SLOT(accept()) );

	yLine = new QLineEdit( this, "YLine" );
	yLine->setGeometry( 40, 50, 125, 25 );
	yLine->setText( "" );
        connect( yLine, SIGNAL(returnPressed()), SLOT(accept()) );

	QPushButton *OkButton,*CancButton;
	OkButton = new QPushButton( this, "OkButton" );
	OkButton->setGeometry( 10, 85, 65, 25 );
	OkButton->setText( "&OK" );
        connect( OkButton, SIGNAL(clicked()), SLOT(accept()) );

	CancButton = new QPushButton( this, "CancelButton" );
	CancButton->setGeometry( 80, 85, 85, 25 );
	CancButton->setText( "&Cancel" );
        connect( CancButton, SIGNAL(clicked()), SLOT(reject()) );

	parent->resize( 175, 120 );
        xLine->setFocus();
}

//**** ResEdMain   ************************************

ResEdMain::ResEdMain( QWidget *parent, const char *name )
    : NWidget( parent, name )
{
    int i,j,k;
    QString s;

//***** Alap menstruktra

    QPopupMenu *file = new QPopupMenu;
    CHECK_PTR( file );
    file->insertSeparator();    
    file->insertItem( "E&xit",       qApp, SLOT(quit()) );

    QPopupMenu *resA = new QPopupMenu;
    CHECK_PTR( resA );
    
    QPopupMenu *insrt = new QPopupMenu;
    CHECK_PTR( insrt );
    
    insrt->insertItem( "&Bitmap", this, SLOT(q_insbmp()) );
    insrt->insertItem( "&Cursor", this, SLOT(q_inscrs()) );
    
    resA->insertItem( "&Make...", this, SLOT(q_new()) );
    resA->insertItem( "&Use...",  this, SLOT(q_use()) );
    resA->insertItem( "&Flush",   this, SLOT(q_flush()) );
    resA->insertSeparator();
    resA->insertItem( "&Insert item...", insrt );
    resA->insertItem( "&Copy...", this,   SLOT(q_cpynew()) );
    resA->insertItem( "&Delete item...",  this, SLOT(q_delete()) );

    QPopupMenu *resB = new QPopupMenu;
    CHECK_PTR( resB );
    resB->insertItem( "&Make...",   this, SLOT(q_newB()) );
    resB->insertItem( "&Use...",    this, SLOT(q_useB()) );
    resB->insertItem( "&Flush",     this, SLOT(q_flushB()) );
    resB->insertSeparator();
    resB->insertItem( "&Delete item...",    this, SLOT(q_deleteB()) );

    QPopupMenu *help = new QPopupMenu;
    CHECK_PTR( help );
    help->insertItem( "&About...", this, SLOT(q_about()) );

    menu = new QMenuBar( this );
    CHECK_PTR( menu );
    menu->insertItem( "&File",  file );
    menu->insertItem( "Resource &A",  resA );
    menu->insertItem( "Resource &B",  resB );
    menu->insertItem( "&Help",  help );
    
//***** Alap Widgetek
    QFont f("Courier", 12);

    lb = new QListBox( this, "listBox" );
    lb->setAutoScroll(FALSE);
    lb->setFont( f );      
    int lbIH = lb->itemHeight();
    lb->resize( lb->width(), ((lb->height()+lbIH)/lbIH)*lbIH +
                lb->frameWidth()*2 );
    connect( lb, SIGNAL(highlighted(int)), SLOT(ItemHighlighted(int)) );
    connect( lb, SIGNAL(selected(int)),    SLOT(ItemSelected(int)) );
    numItem=0;
    
    Blb = new QListBox( this, "listBox" );
    Blb->setAutoScroll(FALSE);
    Blb->setFont( f );      
    Blb->resize( Blb->width(), ((Blb->height()+lbIH)/lbIH)*lbIH +
                 Blb->frameWidth()*2 );
//    connect( Blb, SIGNAL(highlighted(int)), SLOT(ItemHighlighted(int)) );
//    connect( Blb, SIGNAL(selected(int)),    SLOT(ItemSelected(int)) );

    Abox = new QLabel(this);
    Abox->setLineWidth(1);
    Abox->setFrameStyle(QFrame::Box | QFrame::Sunken);
    Bbox = new QLabel(this);
    Bbox->setLineWidth(1);
    Bbox->setFrameStyle(QFrame::Box | QFrame::Sunken);


    ABbutt = new QToolButton( this, bmMoveAB);
    BAbutt = new QToolButton( this, bmMoveBA);

    connect(ABbutt,SIGNAL(clicked()),SLOT(q_moveAB()));
    connect(BAbutt,SIGNAL(clicked()),SLOT(q_moveBA()));
   
    strcpy(fname,"");
    strcpy(fnameB,"");
   
    setMinimumSize( WinX, WinY );
    resize(WinX, WinY );
    
    numItem=0;
}

// ******* F objektumok ***********

void ResEdMain::q_new()
{
  char r[256];
  FILE *ki;
  QString z;
  int i;
  
  q_flush();

  QString s( QFileDialog::getOpenFileName(".","*.res") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      nevtoext(r,r,"res");
      strcpy(fname,r);

      ki=fopen(r,"w");
      numItem=0;
      fprintf(ki,"// Resource File for QT Widget kit\n",NULL);
      fprintf(ki,"// Generated by Resource Editor\n",NULL);
      fprintf(ki,"// (c) 1997  Zsolt Borka\n\n",NULL);
      fclose(ki);
    } 
}

void ResEdMain::q_use()
{
  char r[256];
  q_flush();
  QString s( QFileDialog::getOpenFileName(".","*.res") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      q_usefile(r);
    } 
}

void ResEdMain::q_usefile(char *rname)
{
  char r[256],line[256],s1[256],s2[256];
  FILE *be;
  QString z;
  int i;
      nevtoext(r,rname,".res");
      strcpy(fname,r);
      
      z.sprintf("%s",path2fname(fname));
      Abox->setText(z);
      
      be=fopen(r,"r");
      numItem=0;
      while( ! feof(be))
        {
          readln(be,line);
          strsub(s1,line,0,9);
          if(strcmp(s1,"// BITMAP")==0)
            {
              strsub(s2,line,10,strlen(line)-10);
              z.sprintf("[b%.3i] %s",numItem,s2);  
              lb->insertItem( z );
              numItem++;
            }
        }
      rewind(be);  
      while( ! feof(be))
        {
          readln(be,line);
          strsub(s1,line,0,9);
          if(strcmp(s1,"// CURSOR")==0)
            {
              strsub(s2,line,10,strlen(line)-10);
              z.sprintf("[c%.3i] %s",numItem,s2);  
              lb->insertItem( z );
              numItem++;
            }
        }
      fclose(be);
}


void ResEdMain::q_reopen()
{
  char r[256],line[256],s1[256],s2[256];
  FILE *be;
  QString z;
  int i;
  
  lb->hide();
  i=0;
  while(lb->text(0) != NULL)
    lb->removeItem(0);
  lb->show();
  numItem=0;

  strcpy(r,fname);
  be=fopen(r,"r");
  numItem=0;
  while( ! feof(be))
    {
      readln(be,line);
      strsub(s1,line,0,9);
      if(strcmp(s1,"// BITMAP")==0)
        {
          strsub(s2,line,10,strlen(line)-10);
          z.sprintf("[b%.3i] %s",numItem,s2);  
          lb->insertItem( z );
          numItem++;
        }
    }
  rewind(be);  
  while( ! feof(be))
    {
      readln(be,line);
      strsub(s1,line,0,9);
      if(strcmp(s1,"// CURSOR")==0)
        {
          strsub(s2,line,10,strlen(line)-10);
          z.sprintf("[c%.3i] %s",numItem,s2);  
          lb->insertItem( z );
          numItem++;
        }
    }
  fclose(be);
}

void ResEdMain::q_flush()
{
  QString z;
  int i;
  lb->hide();
  i=0;
  while(lb->text(0) != NULL)
    lb->removeItem(0);
  lb->show();
  numItem=0;
  strcpy(fname,"");
  
  z.sprintf("%s",fname);
  Abox->setText(z);
}

void ResEdMain::q_insbmp()
{
  int ix;
  QString s;
  char r[256],bnam[256];
  FILE *ki;
  if(strlen(fname) !=0)
    {
      s.sprintf("%s","bm");
      InputBox d(this, "Enter a bitmap name");
      d.aLine->setText(s);
      d.aLine->selectAll();
      if(d.exec())
        {
          s=d.aLine->text();
          strcpy(bnam,s);
          ki=fopen(fname,"a");
          fprintf(ki,"// BITMAP %s\n",bnam);
          fprintf(ki,"uchar %s[]=\n",bnam);
          fwrite(bmempty,1,sizeof(bmempty),ki);
          fprintf(ki,"\n",NULL);
          fclose(ki);
          resValogat("// BITMAP","bitedit",bnam,".bit");
        }
    }  
  else
    QMessageBox::message("Warning","Have not opened any resource file");  
}

void ResEdMain::q_inscrs()
{
  int ix;
  QString s;
  char r[256],cnam[256];
  FILE *ki;
  if(strlen(fname) !=0)
    {
      s.sprintf("%s","cr");
      InputBox d(this, "Enter a bitmap name");
      d.aLine->setText(s);
      d.aLine->selectAll();
      if(d.exec())
        {
          s=d.aLine->text();
          strcpy(cnam,s);
          ki=fopen(fname,"a");
          
          fprintf(ki,"// CURSOR %s\n",cnam);
          fprintf(ki,"#define %s_width 32\n",cnam);
          fprintf(ki,"#define %s_height 32\n",cnam);
          fprintf(ki,"#define %s_x 0\n",cnam);
          fprintf(ki,"#define %s_y 0\n",cnam);
          fprintf(ki,"static unsigned char %s_m[] = {\n",cnam);
          fwrite(crempty1,1,sizeof(crempty1)-1,ki);
          fprintf(ki,"static unsigned char %s_b[] = {\n",cnam);
          fwrite(crempty2,1,sizeof(crempty2)-1,ki);
          fprintf(ki,"\n",NULL);
          fclose(ki);
          resValogat("// CURSOR","crsedit",cnam,".crs");
        }
    }  
  else
    QMessageBox::message("Warning","Have not opened any resource file");  
}

void ResEdMain::q_cpynew()
{
  FILE *be,*ki;
  bool b;
  QString s;
  char r[256],tm1[256],tmp[256],line[256],n2[256],s1[256],s2[256];
  char k;
  int i,x,y;
  
  strcpy(r,lb->text(lb->currentItem()));
  k=r[1];
  strsub(r,r,7,strlen(r)-7);
  
  if(strlen(fname) !=0)
    {
      if(k=='b')
        sprintf(tmp,"// BITMAP %s",r);
      else if(k=='c')
        sprintf(tmp,"// CURSOR %s",r);
      
      s.sprintf("%s",r);
      InputBox d(this, "Enter a bitmap name");
      d.aLine->setText(s);
      d.aLine->selectAll();
      if(d.exec())
        {
          s=d.aLine->text();
          strcpy(tm1,s);
          
          strcpy(n2,tmpnam(n2));
          strcat(n2,".res");

          be=fopen(fname,"r");
          ki=fopen(n2,"w");

          do
            {
              readln(be,line);
              if(feof(be))
                break;
              if(strcmp(line,tmp)==0)
                {
                  if(k=='b')
                    {
                       readln(be,line);
                       readln(be,line);
                       fprintf(ki,"// BITMAP %s\nuchar %s[]=\n{\n",tm1,tm1);
                    }
                  else if(k=='c')
                    {
                       readln(be,line);
                       readln(be,line);
                       readln(be,s1);
                       readln(be,s2);
     
                       i=strlen(r);
  
                       strsub(s1,s1,10+i,strlen(s1)-10-i);
                       strsub(s2,s2,10+i,strlen(s2)-10-i);
  
                       x=atoi(s1);
                       y=atoi(s2);

                       readln(be,line);
                    
                       fprintf(ki,"// CURSOR %s\n",tm1);
                       fprintf(ki,"#define %s_width 32\n",tm1);
                       fprintf(ki,"#define %s_height 32\n",tm1);
                       fprintf(ki,"#define %s_x %i\n",tm1,x);
                       fprintf(ki,"#define %s_y %i\n",tm1,y);
                       fprintf(ki,"static unsigned char %s_m[] = {\n",tm1);
                    }
                  while( TRUE )
                    {
                      readln(be,line);
                      if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                        break;
                      if(strncmp(line,"static unsigned",15)==0)
                        fprintf(ki,"static unsigned char %s_b[] = {\n",tm1);
                      else  
                        fprintf(ki,"%s\n",line);  
                    }
                  if(strlen(line)>0)
                    fprintf(ki,"%s\n",line);
                } 
            }  while( ! feof(be));
          fprintf(ki,"\n\n",NULL);  
          fclose(ki);
          fclose(be);
          
          be=fopen(n2,"r");
          ki=fopen(fname,"a");
          while(TRUE)
            {
               readln(be,line);
               if(strlen(line)==0 || feof(be))
                  break;
               fprintf(ki,"%s\n",line);  
            }
          fprintf(ki,"\n\n",NULL);  
          fclose(ki);
          fclose(be);
          
          remove(n2);
          q_reopen();  
        }
    }  
  else
    QMessageBox::message("Warning","Have not opened any resource file");  
}

void ResEdMain::q_delete()
{
  QString z;
  char line[256],r[256],s[256],tmp[256],n2[256];
  char k;
  FILE *be,*ki;
  strcpy(r,lb->text(lb->currentItem()));
  k=r[1];
  strsub(r,r,7,strlen(r)-7);
  if(QMessageBox::query("Message","Do you want to delete it?"))
    {
      strcpy(n2,tmpnam(n2));
      strcat(n2,".res");
      be=fopen(fname,"r");
      ki=fopen(n2,"w");

      if(k=='b')
        sprintf(tmp,"// BITMAP %s",r);
      else if(k=='c')
        sprintf(tmp,"// CURSOR %s",r);

      do
        {
          readln(be,line);
          if(strcmp(line,tmp)!=0 && ! feof(be))
            fprintf(ki,"%s\n",line);
          else  
            {
              while( TRUE )
                {
                  readln(be,line);
                  if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                    break;
                }
              if(strlen(line)>0)
                fprintf(ki,"%s\n",line);
            } 
        }  while( ! feof(be)); 
      fclose(be);
      fclose(ki);
      
      remove(fname);
      rename(n2,fname);
      q_reopen();  
    }
}

void ResEdMain::q_moveAB()
{
  char tx[256],ty[256],tmp[256],line[256],s1[256];
  FILE *be,*ki;
  int i;
  bool b;
  b=FALSE;
  strcpy(tx,lb->text(lb->currentItem()));
  strsub(ty,tx,7,strlen(tx)-7);
  
  for(i=0; i<Blb->count(); i++)
    {
      strcpy(s1,Blb->text(i));
      strsub(tmp,s1,7,strlen(s1)-7);
      b=b | strcmp(ty,tmp)==0;
    }
  
  if(b)
    QMessageBox::message("Warning","I found an existed item in A box");
  else if(strlen(fnameB)==0)
    QMessageBox::message("Warning","Resource B is not open");
  else
    {
       be=fopen(fname,"r");
       ki=fopen(fnameB,"a");
       if(tx[1]=='b')
         sprintf(tmp,"// BITMAP %s",ty);
       else if(tx[1]=='c')
         sprintf(tmp,"// CURSOR %s",ty);
       while( TRUE )
         {
           readln(be,line);
           if(feof(be))
             break;
           else if(strcmp(line,tmp)==0 )
             while( TRUE )
               {
                  fprintf(ki,"%s\n",line);
                  readln(be,line);
                  if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                    break;
               }
          }     
       fclose(be);
       fprintf(ki,"\n\n",NULL);
       fclose(ki);
       q_reopenB();
    }  
}

void ResEdMain::q_moveBA()
{
  char tx[256],ty[256],tmp[256],line[256],s1[256];
  FILE *be,*ki;
  int i;
  bool b;
  b=FALSE;
  strcpy(tx,Blb->text(Blb->currentItem()));
  strsub(ty,tx,7,strlen(tx)-7);
  
  for(i=0; i<lb->count(); i++)
    {
      strcpy(s1,lb->text(i));
      strsub(tmp,s1,7,strlen(s1)-7);
      b=b | strcmp(ty,tmp)==0;
    }
  
  if(b)
    QMessageBox::message("Warning","I found an existed item in A box");
  else if(strlen(fnameB)==0)
    QMessageBox::message("Warning","Resource A is not open");
  else
    {
       be=fopen(fnameB,"r");
       ki=fopen(fname,"a");
       if(tx[1]=='b')
         sprintf(tmp,"// BITMAP %s",ty);
       else if(tx[1]=='c')
         sprintf(tmp,"// CURSOR %s",ty);
       while( TRUE )
         {
           readln(be,line);
           if(feof(be))
             break;
           else if(strcmp(line,tmp)==0 )
             while( TRUE )
               {
                  fprintf(ki,"%s\n",line);
                  readln(be,line);
                  if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                    break;
               }
          }     
       fclose(be);
       fprintf(ki,"\n\n",NULL);
       fclose(ki);
       q_reopen();
    }  
}

void ResEdMain::q_reopenB()
{
  char r[256],line[256],s1[256],s2[256];
  FILE *be;
  QString z;
  int i;
  
  Blb->hide();
  i=0;
  while(Blb->text(0) != NULL)
    Blb->removeItem(0);
  Blb->show();
  numItem=0;

  strcpy(r,fnameB);
  be=fopen(r,"r");
  numItem=0;
  while( ! feof(be))
    {
      readln(be,line);
      strsub(s1,line,0,9);
      if(strcmp(s1,"// BITMAP")==0)
        {
          strsub(s2,line,10,strlen(line)-10);
          z.sprintf("[b%.3i] %s",numItem,s2);  
          Blb->insertItem( z );
          numItem++;
        }
    }
  rewind(be);  
  while( ! feof(be))
    {
      readln(be,line);
      strsub(s1,line,0,9);
      if(strcmp(s1,"// CURSOR")==0)
        {
          strsub(s2,line,10,strlen(line)-10);
          z.sprintf("[c%.3i] %s",numItem,s2);  
          Blb->insertItem( z );
          numItem++;
        }
    }
  fclose(be);
}

void ResEdMain::q_newB()
{
  char r[256];
  FILE *ki;
  QString z;
  int i;
  
  q_flushB();

  QString s( QFileDialog::getOpenFileName(".","*.res") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      nevtoext(r,r,"res");
      strcpy(fnameB,r);
      
      z.sprintf("%s",path2fname(fnameB));
      Bbox->setText(z);

      ki=fopen(r,"w");
      numItem=0;
      fprintf(ki,"// Resource File for QT Widget kit\n",NULL);
      fprintf(ki,"// Generated by Resource Editor\n",NULL);
      fprintf(ki,"// (c) 1997  Zsolt Borka\n\n",NULL);
      fclose(ki);
    } 
}

void ResEdMain::q_useB()
{
  char r[256],line[256],s1[256],s2[256];
  FILE *be;
  QString z;
  int i;
  
  q_flushB();

  QString s( QFileDialog::getOpenFileName(".","*.res") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      nevtoext(r,r,".res");
      strcpy(fnameB,r);

      z.sprintf("%s",path2fname(fnameB));
      Bbox->setText(z);
     
      be=fopen(r,"r");
      numItem=0;
      while( ! feof(be))
        {
          readln(be,line);
          strsub(s1,line,0,9);
          if(strcmp(s1,"// BITMAP")==0)
            {
              strsub(s2,line,10,strlen(line)-10);
              z.sprintf("[b%.3i] %s",numItem,s2);  
              Blb->insertItem( z );
              numItem++;
            }
        }
      rewind(be);  
      while( ! feof(be))
        {
          readln(be,line);
          strsub(s1,line,0,9);
          if(strcmp(s1,"// CURSOR")==0)
            {
              strsub(s2,line,10,strlen(line)-10);
              z.sprintf("[c%.3i] %s",numItem,s2);  
              Blb->insertItem( z );
              numItem++;
            }
        }
      fclose(be);
    } 
}

void ResEdMain::q_flushB()
{
  QString z;
  int i;
  Blb->hide();
  i=0;
  while(Blb->text(0) != NULL)
    Blb->removeItem(0);
  Blb->show();
  numItem=0;
  strcpy(fnameB,"");
  z.sprintf("%s",fnameB);
  Bbox->setText(z);
}

void ResEdMain::q_deleteB()
{
  QString z;
  char line[256],r[256],s[256],tmp[256],n2[256];
  char k;
  FILE *be,*ki;
  strcpy(r,Blb->text(Blb->currentItem()));
  k=r[1];
  strsub(r,r,7,strlen(r)-7);
  if(QMessageBox::query("Message","Do you want to delete it?"))
    {
      strcpy(n2,tmpnam(n2));
      strcat(n2,".res");
      be=fopen(fnameB,"r");
      ki=fopen(n2,"w");

      if(k=='b')
        sprintf(tmp,"// BITMAP %s",r);
      else if(k=='c')
        sprintf(tmp,"// CURSOR %s",r);

      do
        {
          readln(be,line);
          if(strcmp(line,tmp)!=0 && ! feof(be))
            fprintf(ki,"%s\n",line);
          else  
            {
              while( TRUE )
                {
                  readln(be,line);
                  if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                    break;
                }
              if(strlen(line)>0)
                fprintf(ki,"%s\n",line);
            } 
        }  while( ! feof(be)); 
      fclose(be);
      fclose(ki);
      
      remove(fname);
      rename(n2,fname);
      q_reopenB();  
    }
}

void ResEdMain::q_about()
{
  QMessageBox::message( "About", 
  "Resource Editor\nfor X11 programs, that uses QT Widget kit\n\nv 0.1 (beta)\n(c) 1997  by Zsolt Borka");
}

void ResEdMain::ItemHighlighted(int ix)
{
/*  QString s;
  char r[256];
  strcpy(r,lb->text(ix));
  strsub(r,r,7,strlen(r)-7);
  s.sprintf("H:<%s>",r);
  label->setText(s); */
}

void ResEdMain::resValogat(char *form, char *path, char *rn, char *ext)
{
  int i, j, k;
  char line[256], s1[256], s2[256], tmp[256],
       krit[256], n1[256], n2[256], n3[256];  
  char c, *TEMP;
  FILE *be, *ki, *tm;
  QString z;
 
  strcpy(n1,tmpnam(n1));
  strcat(n1,ext);
  
  be=fopen(fname,"r");
  ki=fopen(n1,"w");
  sprintf(tmp,"%s %s",form,rn);
  while( ! feof(be))
    {
      readln(be,line);
      
      if(strcmp(line,tmp)==0)
        {
          fprintf(ki,"%s\n",line);
          while( TRUE )
            {
               readln(be,line);
               if(strlen(line)==0 || feof(be))
                 break;
               fprintf(ki,"%s\n",line);
            }
        }
    }
  fprintf(ki,"\n",NULL);
  fclose(be);
  fclose(ki);

  sprintf(n2,"%s %s",path,n1);
  i=system(n2);
  
// visszatesz n1 --> fname

  strcpy(n2,tmpnam(n2));
  strcat(n2,".res");

  be=fopen(fname,"r");
  ki=fopen(n2,"w");
  sprintf(tmp,"%s %s",form,rn);
  do
    {
      readln(be,line);
      if(feof(be))
        break;
      else if(strcmp(line,tmp)!=0)
          fprintf(ki,"%s\n",line);
      else  
        {
          while( TRUE )
            {
              readln(be,line);
              if(strlen(line)==0 || feof(be) || strncmp(line,"//",2)==0)
                break;
            }
          
          tm=fopen(n1,"r");  
          while( TRUE )
            {
              readln(tm,s2);
              if(strlen(s2)==0 || feof(be) )
                break;
              fprintf(ki,"%s\n",s2);
            }
          fclose(tm);             
          fprintf(ki,"\n",NULL);
        } 
    }  while( ! feof(be));
      
  fclose(be);
  fclose(ki);

// **** vissza

  remove(fname);
  rename(n2,fname);
  remove(n1);
  
  q_reopen();  
}

void ResEdMain::ItemSelected(int ix)
{
  QString s;
  char r[256];
  ixItem=ix;
  
  strcpy(r,lb->text(ix));
  if(strlen(r)!=0)
    if(r[1]=='b')
      {
        strsub(r,r,7,strlen(r)-7);
        resValogat("// BITMAP","bitedit",r,".bit");
      }
    else if(r[1]=='c')
      {
        strsub(r,r,7,strlen(r)-7);
        resValogat("// CURSOR","crsedit",r,".crs");
      }
  lb->setCurrentItem(ix);
}

// ******* zenetek ****************

void ResEdMain::resizeEvent( QResizeEvent * )
{
   int i,j;

   Abox->setGeometry( 2, menu->height()+2, width()/2-22, 20 );
   Bbox->setGeometry( width()/2+20, menu->height()+2, width()/2-22, 20);
   
    lb->setGeometry( 0, menu->height()+25, 
                     width()/2-18, height()-menu->height()-30 );
   Blb->setGeometry( width()/2+18, menu->height()+25, 
                     width()/2-18, height()-menu->height()-30);
                     
   ABbutt->setGeometry( width()/2-18, menu->height()+25, 
                          35, 21);
   BAbutt->setGeometry( width()/2-18, menu->height()+50+24, 
                          35, 21);                  
}

// ******* Fprogram ***************

#include "resedit.moc"

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    ResEdMain m;

    if(argc>1)
      {
         m.isPreload=TRUE;
         m.q_usefile(argv[1]);
      }
    
    QPixmap pmap;
    pmap.loadFromData((unsigned char *) &rock50,bitmapSize(rock50));
    m.setBackgroundPixmap(pmap);

    a.setMainWidget( &m );
    m.show();
    return a.exec();
}
